### Listes 
##Exo2

def vide():
    return None
    
def cons(x,L):
    return(x,L)
    
def ajouteEnTete(x,L):    
    return cons(x,L)

def supprEnTete(L):
    return(L[0],L[1])
    
def estVide(L):
    return L is None

def compte(L):
    if estVide(L):
        return 0
    return 1 + compte(L[1])
    

def element_n(n, L): # accéder à élément n de la liste
    if n >0:
        return element_n(n-1,L[1])
    else:
        return L[0]

##Exo1 avec fct° exo2
"""
>>> l = vide()

>>> ajouteEnTete(10,l)  #
(10, None)

>>> ajouteEnTete(9,l)  #
(9, None)

>>> ajouteEnTete(8,l)  #l ne change pas de longueur à chq fois
(8, None)

>>> l

>>> l=ajouteEnTete(8,l)

>>> l
(8, None)

>>> l=ajouteEnTete(9,l)

>>> l
(9, (8, None))

>>> l=ajouteEnTete(10,l) # nommé la liste qui se construit

>>> l
(10, (9, (8, None)))

>>> l1=cons(5,cons(4,cons(3,l)))

>>> l1
(5, (4, (3, (10, (9, (8, None))))))
"""
  
##exo3 a) 
"""
>>> l = vide()

>>> l=cons(12,cons(14,cons(8,cons(7,cons(19,cons(22,l))))))

>>> l
(12, (14, (8, (7, (19, (22, None))))))

>>> t1,q1=supprEnTete(l)

>>> t2,q2=supprEnTete(q1)

>>> l_bis=cons(t1,cons(t2,cons(42,q2)))

>>> l_bis
(12, (14, (42, (8, (7, (19, (22, None)))))))

>>> 
"""


##exo3 b) accéder aux éléments de la liste
"""
>>> l = vide()

>>> l = cons(3,cons(8,cons(0,cons(12,cons(9,l)))))

>>> l
(3, (8, (0, (12, (9, None)))))

>>> l[0]
3

>>> l[1]
(8, (0, (12, (9, None))))

>>> l[1][0]
8

>>> l[1][1]
(0, (12, (9, None)))

>>> l[1][1][1]
(12, (9, None))

>>> 
"""
### Piles 
##exo4 a) Piles avec cons
"""
def vide():
    return None
    
def cons(x,L):
    return(x,L)
    
def push(L,x):    
    return cons(x,L)

def pop(L):
    return(L[0],L[1])
    
def sommet(p):
    return p[0]
    
def estVide(L):
    return L is None

def taille(L):
    if estVide(L):
        return 0
    return 1 + taille(L[1])
"""
"""
def vide():
    return None
    
def cons(x,L):
    return(x,L)

def push(p,x):
    ps=cons(x,p)    
    return ps    

def pop(p):
    t = p[0]
    p = p[1]
    return t,p
    
def sommet(p):
    return p[0]

def estVide(L):
    return L is None

def pile_vide(p):
    if p is None:
        return "Vrai"
    return 'Faux'

def taille(L):
    if estVide(L):
        return 0
    return 1 + compte(L[1])
"""

##exo4
"""
>>> p=vide()

>>> p=cons(67,cons(45,cons(32,cons(11,cons(15,p)))))

>>> t,p=pop(p)

>>> p
(45, (32, (11, (15, None))))

>>> p=push(p,4)
>>> p
(4, (45, (32, (11, (15, None)))))

>>> p=push(p,8)
"""

##exo4 b) Piles avec list
"""
def push(p,x):
    p =p.append(x)
    return p
    
def pop(p):
    t = p.pop()
    return t, p
    
def sommet(p):
    return p[-1]

def taille(p):
    return len(p)
    

"""
### Files 

##Files avec cons c) exemples
"""
def enqueue(f, x):
    #ajoute un élément dans la file
    
    return cons(x,f)

       
def dequeue(f):
    if estVide(f) == True:
        return None 
    elif f[1] ==[]:
        return f[0]
    else:
        dequeue(f[1])

def sommet(f):
    while f[1] is not None:        
        return sommet(f[1])   
    return f"La tête est {f[0]}"
   
def retire(f):
    l=[]
    while f[1] is not None:       
        l.append(f[0])
        print(l)
        return retire(f[1])
#    return f[1]
    file = vide()
    for i in range(len(l)+1):
       file=cons(i,file)
    return file
    
f = vide()
f = cons(12,cons(14,cons(8,cons(7,cons(19,cons(22,f))))))
print("f:",f)

"""
##exo5 d) Files avec list 
"""
def ajout(f,x):
   f = f.append(x) 
   return f
   
def retire(f):
    x=f[0]
    f.pop(0)
    return (x,f)
    
def avant(p):
    return f[0]
    
def est_vide(f):
    if f == []: # ou bien if f is None :
        return True
    else:
        return False

def taille(f)   :
    return len(f)

"""
##utilisation du module deque 
from collections import deque

queue = deque(["Eric", "John", "Michael"])
queue.append("Terry") 
print(queue)          		# Terry arrive
queue.append("Graham")  
print(queue)        		# Graham arrive
queue.popleft() 
print(queue)                # le premier arrivé est enlevé

queue.popleft()
print(queue)                # le deuxième arrivé est enlevé



###Exercices

## Exo7 a) pile en objet

class Pile:
    def __init__(self):
        self.taille = 0
        self.valeur=[]
        
    def empiler(self, x):
        self.taille = self.taille + 1
        self.valeur.append(x)
        
    def depiler(self):
        self.taille = self.taille - 1
        return self.valeur.pop()
    
    def pile_vide(self):
        return self.taille == 0
        
    def sommet(self):
        if self.taille > 0:
            return self.valeur[-1]
            
    def affiche(self):
        print(self.valeur)
        
    def __str__(self):
        return str(self.valeur)
        
## Exo7 b) file en objet
class File:
    def __init__(self):
        self.taille = 0
        self.valeur=[]
        
    def enfiler(self, x):
        self.taille = self.taille + 1
        self.valeur.append(x)
        
    def defiler(self):
        self.taille = self.taille - 1
        return self.valeur.pop(0)
    
    def file_vide(self):
        return self.taille == 0
        
    def sommet(self):
        if self.taille > 0:
            return self.valeur[0]
            
    def affiche(self):
        print(self.valeur)
        
    def __str__(self):
        return str(self.valeur)

